/*
 *
 * Copyright (C) 2003,2004 by 4system Polska Sp. z o.o.
 * All Rights Reserved.
 *
 * $Id: element.js,v 1.29 2005/01/05 09:43:37 s.domanski Exp $
 *
 */ 

componentElement = function()
{
	this.WBTObject = WBTObject;
	this.WBTObject();
	
	var a=arguments;
	if (a[0]) this.setID(a[0]);
	this.x=a[1]||0;
	this.y=a[2]||0;
	this.w=a[3]||null;
	this.width=this.w;
	this.h=a[4]||null;
	this.height=this.h; 
	this.bgColor=a[5]||null;
	
	this.visible = false;
	this.visibleIf = "";
	this.contentMode = 0;
	
	this.enabled = true;        
	this.z=a[7]||0;
	this.bgImage=a[8]||null;
	this.html=a[9]||null;   
	this.cursor = "default";
	this.borderWidth = 0;
	this.borderColor = "transparent";
	
	this.obj=null;
	this.doc=null;
	this.style=null;   
	
	this.step = 0;
	
	this.eventListeners = [];
	
	this.canDragging = false;
	this.dockSite = false;
	
	this.locked = false;
	this.isCreated = false;
	this.actionOn = false;
	this.clearIncorectAnswer = false;
	this.checkLock = false;
	this.visual = true;
	this.stayOnTop = false;
	this.stopPropagation = false;
	this.alphaOpacity = null;
	this.altHint = null;
}

componentElement.prototype = new WBTObject();
componentElement.prototype.isComponentElement = true;
componentElement.prototype.type = "componentElement";
componentElement.prototype.version = "$Revision: 1.29 $";

componentElement.prototype.specificCreate = function()
{
	this.visible = this.isVisible();
	if (this.stayOnTop) {
		this.z = 1000;
	}
	
	if (!this.parent||this.obj) return; 
	if (is.moz) {
		var parentElement=(this.parent.isComponentElement)?this.parent.obj:this.parent.doc.body;
		var r=parentElement.ownerDocument.createRange();
		r.setStartBefore(parentElement);
		var html = r.createContextualFragment(this.__getOuterHTML());
		parentElement.appendChild(html);
		this.obj=parentElement.lastChild;
		this.style = this.obj.style;
		this.doc = this.parent.doc;
		this.style.zIndex = this.z;
	} else if (is.ie) {
		var parentElement=(this.parent.isComponentElement)?this.parent.obj:this.parent.doc.body;
		parentElement.insertAdjacentHTML("beforeEnd",this.__getOuterHTML());
		this.obj=parentElement.children[parentElement.children.length-1];
		this.style=this.obj.style;
		this.doc=this.parent.doc;   
	} else if (is.ns4) {
		var recycled = this.parent.doc.recycled;
		if (this.created) recycled = [];
		if (recycled && recycled.length > 0) {
			this.obj = recycled[recycled.length-1];
			recycled.length--;
		} else {
			this.obj = new Layer(this.w, this.parent.obj);
			this.obj.captureEvents(Event.LOAD);
			this.obj.onload = function() {};
			this.bt = this.ns4LayerCreate(this.x, this.y, this.w, 0, this.visible, "");
			this.bb = this.ns4LayerCreate(this.x, this.y + this.h, this.w, 0, this.visible, "");
			this.bl = this.ns4LayerCreate(this.x, this.y, 0, this.h, this.visible, "");
			this.br = this.ns4LayerCreate(this.x + this.w, this.y, 0, this.h, this.visible, "");
		}
		
		this.style=this.obj;
		this.doc=this.obj.document;
		this.doc.owner=this;          
		if(this.w) this.style.clip.width = this.w;
		if(this.h) this.style.clip.height = this.h;          
		this.obj.moveTo(this.x,this.y);          
		if (this.bgColor!=null) this.setBgColor(this.bgColor); 
		if (this.clip) this.setClip(this.clip);
		this.style.zIndex=this.z; 
		this.style.visibility=this.visible? "inherit" : "hide"; 
		this.setHTML(this.html);
	}
	this.obj.owner = this;
	this.setHTML(this.html);
	this.setCursor(this.cursor);
	this.setBorder(this.borderColor, this.borderWidth);
	this.className = 'element';
}  

componentElement.prototype.specificRemove = function()
{
	if (is.def && this.obj) {
		if (is.ns4) {
			if (!this.parent.doc.recycled) this.parent.doc.recycled=[];
			this.parent.doc.recycled[this.parent.doc.recycled.length]=this.obj;
			this.obj.visibility="hide";
		} else this.obj.style.visibility = "hidden";
		
		this.obj.innerHTML = "";
		this.obj.outerHTML = "";
	}  else if (is.ns4 && this.obj) {
		if (!this.parent.doc.recycled) this.parent.doc.recycled=[];
		this.parent.doc.recycled[this.parent.doc.recycled.length]=this.obj;
		this.obj.visibility="hide";
	}
	
	this.html = null;
	this.z = null;
	this.w = null;
	this.h = null;
	this.obj = null;
	this.doc = null;
	this.style = null;   
};


componentElement.prototype.ns4LayerCreate = function(x, y, w, h, visible, text) 
{
	var l = new Layer (w, self);
	l.visibility = visible;
	l.left = x;
	l.top = y;
	l.clip.height = h;
	l.clip.width = w;
	l.bgColor = "#ff0000";
	return l
}

componentElement.prototype.__getOuterHTML=function() 
{
	if (is.def) {
		var s = '<div id="'+this.id+'"';
		if (this.altHint != null) s += ' title="' + this.altHint + '"';
		s += ' style="';
		s += " visibility:" + ((this.visible) ? "inherit" : "hidden") + ";"; 
		if (this.x!=null) s += ' left:' + this.x + 'px;';
		if (this.y!=null) s += ' top:' + this.y + 'px;';
		if (this.w!=null) s += ' width:' + this.w + 'px;';
		//if (this.w!=null) s += ' width:' + ((this.fitWidthToPage) ? '100%;' : this.w + 'px;');
		if (this.h!=null) s += ' height:' + this.h + 'px;';
        if (this.clip) s += ' clip:rect(' + this.clip[0] + 'px ' + this.clip[1] + 'px ' + this.clip[2] + 'px ' + this.clip[3] + 'px);';
		else if (this.w != null && this.h != null) s += ' clip:rect(0px ' + this.w + 'px ' + this.h + 'px 0px);';
		if (this.z) s += ' z-index=' + this.z + ';';
		if (this.bgColor != null) s += ' background-color:' + this.bgColor + ';';
		s += ' position:absolute;';
		//s += ' filter:blur(add=true, direction=90, strength=6)';
		//s += ' filter:gray;';
		//s += ' filter:alpha(opacity=20, finishopacity=100, style=1, startx=0, starty=0, finishx=140, finishy=270)';
		if (this.alphaOpacity != null) {
			s += ' filter:alpha(opacity=' + this.alphaOpacity + ');';
			s += ' -moz-opacity:' + (this.alphaOpacity / 100) + ';';
		}
		s += '">';
		if (this.html != null) s += this.html;
		s += '</div>';
		
		return s;
	}
};  

componentElement.prototype.moveTo = function(x, y, noevt)
{
	if (x != null) this.x = x;
	if (y != null) this.y = y;
	if (this.style == null) return;
	this.__setX(this.x);
	this.__setY(this.y);
	
	if (is.ns4) {
		this.bt.left = this.x;
		this.bt.top = this.y;
		this.bb.left = this.x;
		this.bb.top = this.y + this.h - this.borderWidth;
		this.bl.left = this.x;
		this.bl.top = this.y;
		this.br.left = this.x + this.w - this.borderWidth;
		this.br.top = this.y;
	}
	
	if (noevt != false) this.invokeEvent('Move');
}; 

componentElement.prototype.moveBy = function(x, y, noevt)
{
	this.moveTo(this.x + x, this.y + y, noevt);
}; 

componentElement.prototype.__setX = function(x)
{
	if (is.ie) {
		this.style.pixelLeft = x;
	} else {
		if (is.ns4) {
			this.style.left = x + this.borderWidth - ((this.parent != page) ? this.parent.borderWidth : 0);
		} else {
			this.style.left = x;
		}
	}
};

componentElement.prototype.__setY = function(y)
{
	if (is.ie) {
		this.style.pixelTop = y;
	} else {
		if (is.ns4) {
			this.style.top = y + this.borderWidth - ((this.parent != page) ? this.parent.borderWidth : 0);
		}  else {
			this.style.top = y;
		}
	}
};

componentElement.prototype.setX = function(x, noevt)
{
	this.moveTo(x, null, noevt);
};

componentElement.prototype.setY=function(y, noevt)
{
	this.moveTo(null, y, noevt);
};

componentElement.prototype.setClip = function(clip)
{
	this.clip = clip;
	if (this.style == null) return;
	if (is.ns4) {
		this.obj.clip.top = clip[0];
		this.obj.clip.right = clip[1];
		this.obj.clip.bottom = clip[2];
		this.obj.clip.left = clip[3];
	} else {
		this.css.clip="rect("+clip[0]+"px "+clip[1]+"px "+clip[2]+"px "+clip[3]+"px)";
	}
}; 

componentElement.prototype.setVisible = function(b)
{
	if (this.style == null || !this.visual) return;
	this.visible = b;
	this.style.visibility = (b) ? "inherit" : (is.ns4 ? "hide":"hidden");
	if (is.ns4) {
		this.bt.visibility = this.bb.visibility = this.style.visibility;
		this.bl.visibility = this.br.visibility = this.style.visibility;
	}
	if(this.actionOn) {  
		if(b) {
			this.invokeEvent('Show');
		} else {
			this.invokeEvent('Hide');
		}  
	}
};

componentElement.prototype.setEnabled = function(b)
{
	this.enabled = b;
	for (var i=0; i<this.children.length;i++) {
		if (this.children[i].isComponentElement) this.children[i].setEnabled(b);
	}
}

componentElement.prototype.setZIndex=function(z)
{
	this.z = z;
	if (this.style == null) return;
	this.style.zIndex = z;
};

componentElement.prototype.setBgColor = function(color)
{
	if (is.ns4 && color == "transparent") {
		color = "";
	}
	if (color == null || color == "null") {
		color = (is.ns4) ? "" : "transparent";
	}
	
	if (this.style == null) return;
	if (is.ns4) {
		this.doc.bgColor = color;
	} else  {
		this.style.backgroundColor = color;
	}
};

componentElement.prototype.setCursor = function(c)
{
	this.cursor = c;
	if (this.style) this.style.cursor = c;
}

componentElement.prototype.setBorder = function(c, w)
{
	if (c.match(/^transparent/i)) {
		this.style.borderStyle = "none";
		this.style.borderWidth = "0";
		this.style.padding = w;
	} else {
		if (is.ns4) {
			this.bt.clip.height = w;
			this.bt.document.bgColor = c;
			
			this.bb.clip.height = w;
			this.bb.top = this.y + this.h - w;
			this.bb.document.bgColor = c;
			
			this.bl.clip.width = w;
			this.bl.document.bgColor = c;

			this.br.clip.width = w;
			this.br.left = this.x + this.w - w;
			this.br.document.bgColor = c;

			this.moveTo(this.x, this.y);
			this.setSize(this.w, this.h);
		} else {
			this.style.padding = "0";
			this.style.borderStyle = "solid";
			this.style.borderColor = c;
			this.style.borderWidth = w;
		}
	}
}

componentElement.prototype.__setOwnerDOM = function(obj)
{
	var ln = obj.childNodes;
	for (var i = 0; i < ln.length; i++) {
		ln[i].owner = this;
		this.__setOwnerDOM(ln[i]);
	}  
}

componentElement.prototype.__setHTML=function(html)
{
	if(is.ns4) {
		var sTmp = (this.w == null) ? '<NOBR>' + this.html + '</NOBR>' : this.html;
		var s = "";
		for (i = 0; i < sTmp.length; i++) {
			s += (sTmp.charCodeAt(i) > 160) ? "&#" + sTmp.charCodeAt(i) + ";" : sTmp.charAt(i);
		}	
		this.doc.open();
		this.doc.write(s);
		this.doc.close();
		for (var i=0;i<this.doc.images.length;i++) this.doc.images[i].owner=this;
		for (i=0;i<this.doc.links.length;i++) this.doc.links[i].owner=this;
	} else {
		if (html) this.obj.innerHTML=unescape(html);
		if (is.ie) {
			var ln = this.obj.all;
			for (var i = 0; i < ln.length; i++) ln[i].owner = this;
		} else if (is.dom) {
			this.__setOwnerDOM(this.obj);  
		}
	}
}

componentElement.prototype.setHTML = function(html)
{
	this.html = html ? html : '';
	if (is.platform == "mac") this.html += '\n';
	if (this.style == null) return;
	this.invokeEvent("BeforeLoad");
	this.__setHTML(html);
	this.invokeEvent("Load");
}

componentElement.prototype.setSize = function(w, h, noevt)
{
	this.w = (w == null) ? this.w:w<0 ? 0:w;
	this.h = (h == null) ? this.h:h<0 ? 0:h;
	if (this.w == null && this.h == null) return;
	if (this.style != null) {
		if (is.ns4) {
			this.style.clip.width = this.w - (this.borderWidth * 2);
			this.style.clip.height = this.h - (this.borderWidth * 2);
		} else {
			this.setWidth(w);
			this.setHeight(h);
		}
	}
	if(noevt != false) this.invokeEvent('Resize');
}; 

componentElement.prototype.setWidth=function(w, noevt)
{
	this.width = this.w = ( w == null ) ? this.w : w < 0 ? 0 : w;
	if (this.w == null) return;

	if (this.style != null) {
		if ( is.ns4 ) this.style.clip.width = this.w;
		else {
			this.style.width = (is.moz) ? this.w - (this.borderWidth * 2) : this.w;
			this.style.clip = 'rect(0px ' + (this.w || 0) + 'px ' + (this.h || 0) + 'px 0px)';
		}
	}
	if (noevt != false) this.invokeEvent('Resize');
}; 

componentElement.prototype.setHeight=function(h, noevt)
{
	this.height = this.h = ( h == null) ? this.h : h < 0 ? 0 : h;
	if (this.h == null) return;
	if (this.style != null) {
		if (is.ns4) this.style.clip.height = this.h;
		else {
			this.style.height = (is.moz) ? this.h - (this.borderWidth * 2) : this.h;
			this.style.clip = 'rect(0px ' + (this.w || 0) + 'px ' + (this.h || 0) + 'px 0px)';
		}
	}
	if (noevt != false) this.invokeEvent( 'Resize' );
};

componentElement.prototype.paint = function()
{
	if (this.created) {
		this.moveTo(this.x, this.y, false);
		this.setSize(this.w, this.h, false);
		this.setCursor(this.cursor);
		if (this.parent.type == "componentPage" && (page.state==psPreview || page.state==psDesigning)) {
			if (page.state == psPreview && !page.previewShowHiddenElements) {
				if (parseInt(this.step) != STEPS_HIDDEN) {
					this.step = 0;
					this.setVisible(true);
				} else {
					this.setVisible(false);
				}
			} else {
				this.step = 0;
				this.setVisible(true);
			}
		} else {
			this.setVisible(this.visible);
		}
		this.setBgColor(this.bgColor);
		this.invokeEvent("Paint");
		var l = this.children.length;
		for (var i = 0; i < l; i++) this.children[i].paint();
	}
}; 

componentElement.prototype.lock = function()
{
	this.locked = true;
	this.invokeEvent("Lock");
};

componentElement.prototype.unLock = function()
{
	this.locked = false;
	this.invokeEvent("UnLock");
};

componentElement.prototype.onLock = function()
{
	return(true);
};

componentElement.prototype.onUnLock = function()
{
	return(true);
};

componentElement.prototype.Step = function()
{
	if (this.invokeEvent("Step") != true) {
		if (this.isVisible()) this.setVisible(true);
	}
}

componentElement.prototype.addEventListener=function(listener)
{
	for (var i=0;i<this.eventListeners.length;i++) {
		if (this.eventListeners[i]==listener) return;
	}
	this.eventListeners[this.eventListeners.length]=listener;
}; 

componentElement.prototype.removeEventListener=function(listener)
{
	for (var i = 0; i < this.eventListeners.length; i++) {
		if (this.eventListeners[i]==listener) this.eventListeners.splice(i, 1);
	}
}; 
 
componentElement.prototype.captureMouseEvents = function()
{
	var obj = this.obj
	if (!obj) return

	if (is.ns4) obj.captureEvents(Event.MOUSEDOWN | Event.MOUSEUP | Event.CLICK | Event.DBLCLICK);

	obj.onmousedown=mouseEvent.eventMethod;
	obj.onmouseup=mouseEvent.eventMethod;
	obj.onmouseover=mouseEvent.eventMethod;
	obj.onmouseout=mouseEvent.eventMethod;
	obj.onclick=mouseEvent.eventMethod;
	obj.ondblclick=mouseEvent.eventMethod;
}  

componentElement.prototype.onMouseMove = function() {return false;};
componentElement.prototype.onMouseDown = function() {return false;};
componentElement.prototype.onMouseUp = function() {return false;};
componentElement.prototype.onMouseOver = function() {return false;};
componentElement.prototype.onMouseOut = function() {return false;};
componentElement.prototype.onClick = function() {return false;};
componentElement.prototype.onDblClick = function() {return false;};

componentElement.prototype.eventMouseMove = function(e)
{
	if (this.onMouseMove(this)) return true;
	if (this.parent && this.parent.eventMouseMove) this.parent.eventMouseMove(e);
	return false;
};

componentElement.prototype.eventMouseDown = function(e)
{
	if (this.onMouseDown(this)) return true;
	if (this.parent && this.parent.eventMouseDown) return this.parent.eventMouseDown(e);
	return false;
};

componentElement.prototype.eventMouseUp = function(e)
{
	if (this.onMouseUp(this)) return true;
	if (this.parent && this.parent.eventMouseUp) this.parent.eventMouseUp(e);
	return false;
};

componentElement.prototype.eventMouseOver = function(e)
{
	if (this.onMouseOver(this)) return true;
	if (this.parent && this.parent.eventMouseOver) this.parent.eventMouseOver(e);
	return false;
};

componentElement.prototype.eventMouseOut = function(e)
{
	if (this.onMouseOut(this)) return true;
	if (this.parent && this.parent.eventMouseOut) this.parent.eventMouseOut(e);
	return false;
};

componentElement.prototype.eventClick = function(e)
{
	if (this.onClick(this)) return true;
	if (this.parent && this.parent.eventClick) this.parent.eventClick(e);
	return false;
}

componentElement.prototype.eventDblClick = function(e)
{
	if (this.onDblClick(this)) return true;
	if (this.parent && this.parent.eventDblClick) this.parent.eventDblClick(e);
	return false;
};

componentElement.prototype.actionHideObject = function() 
{
	this.setVisible(false);
	this.paint();
}

componentElement.prototype.actionShowObject = function() 
{
	this.setVisible(true);
	this.paint();
}

componentElement.prototype.isReady = function()
{
	return(true);
};

componentElement.prototype.parseCheckAnswer = function(obj)
{
	if (!obj || page.isExam) return(false);
	var splitStr = "";
	var isCorrect = false;
	var actAnswer = obj.getAnswer().toString();
	var arrCorrAns = new Array();
	
	switch (obj.className) {
		case "TrackBar":
			splitStr = ",";
			break;
		default: splitStr = "||";
	}
	
	arrCorrAns = obj.correctAnswer.toString().split(splitStr);
	
	for (var i = 0; i < arrCorrAns.length; i++) {
		if (actAnswer == arrCorrAns[i]) isCorrect = true;
	}
	return(isCorrect);
};

componentElement.prototype.unselectable = function()
{
	if (is.ie) {
		this.obj.unselectable = "on";
		for (var i=0; i<this.children.length; i++) {
			this.children[i].unselectable();
		}
	} else if (is.moz) {
		this.obj.style.setProperty("-moz-user-select", "None", "");
	}
};

componentElement.prototype.returnError = function(err)
{
	if (typeof(err) == "object") {
		log.error(err.message, "Error: " + this.id + " : [" + err.number + "] : ");
	} else {
		log.error(err.message, "Error: " + this.id + " : " + err);
	}
};

componentElement.prototype.isVisible = function()
{
	if (page.state == psPreview || page.state == psDesigning) return true;
	if (!this.visual) return (false);
	var result = (page.stepIndex >= this.step && this.step != STEPS_HIDDEN && this.step != STEPS_LAST_STEP);
	if (result) result = (this.contentMode == sys.contentMode || this.contentMode == 0 || (this.contentMode == -1 && sys.contentMode == 0));
	if (result && this.visibleIf != "") result = (eval(unescape(this.visibleIf)) == true);
	return result;
};
/********************************************************************/
