/*
 * Name: Page 
 * Type: WBTApi
 *
 * Copyright (C) 2003,2004 by 4system
 * All Rights Reserved.
 *
 * $Id: page.js,v 1.79 2005/02/07 14:24:42 a.wojtis Exp $
*/ 

//consts
STEPS_HIDDEN = -1;
STEPS_LAST_STEP = -2;

function getPageUrl() {
	var href = location.href;
	var index = href.indexOf('?');
	if (index > 0) {
		href = href.substr(0, href.indexOf('?'));
	}
	var index = href.lastIndexOf("/");
	if (index > 0) {
		href = href.substr(0, index);
	}
	return href + '/';
}  

function urlCanonicalize(url, absolute)
{
	if (absolute) url = pageURL + url;
	var arr = url.split('/');
	var url = '';
	for (var i=0; i<arr.length; i++) {
		if (arr[i + 1] != '..' && arr[i + 1] != 'undefine' && arr[i] != '..') {
			if (i == arr.length - 1 && arr[i] == '') break;
			url += arr[i] + '/';
		}
	}
	
	if (url.substr(2, 1) == ':') url = 'file:///' + url;
	
	return(unescape(url));
}

var me = new Array();
var sys = new Array();
var pageURL = getPageUrl();

//--

Vars = function() {};

Vars.prototype.get = function(struct)
{
	var result = new Array();
	for (var k in struct) {
		result[result.length] = struct[k].toString().replace(/,/g, "%2C");
	}
	return result.toString();
};

Vars.prototype.set = function(struct, v)
{
	if (typeof(v) != "string" || v == "") return;
	var arr = v.split(",");
	var i = 0;
	for (var k in struct) {
		struct[k] = unescape(arr[i++]);
		if (i >= arr.length) break;
	}
};

Vars.prototype.init = function(v)
{
	var result = new Array();
	for (var k in v) {
		result[k] = v[k];
	}
	return result;
};

Vars.prototype.load = function(struct, name)
{
	var v = lms.getCourseData(name);
	if (v != null) {
		this.set(struct, v)
	}
};

Vars.prototype.save = function(struct, name)
{
	var s = this.get(struct);
	lms.setCourseData(name, s);
};

vars = new Vars();

//----------------------------

function pageCreate()
{
	page.create();
}

function pageDestroy()
{
	if (page) {
		page.free();
		lms.free();
		destroy(page);
		page = null;
		destroy(lms);
		lms = null;
		document.body.onunload = null;
	}
}

componentPage = function()
{
	this.doc = self.document;
	this.style = null;
	this.obj = null;
	this.style = (is.ns4) ? self : null;
	this.obj = (is.ns4) ? self : null;

	this.WBTObject = WBTObject;
	this.WBTObject();
	this.feedbackOkName = "feedbackOk";
	this.feedbackBadName = "feedbackBad";
	this.feedbackLastBadName = "feedbackLastBad";
	this.feedbackNotOkName = "feedbackNotOk";

	//zmienne
	this.countAnswers = 2;
	this.maxScore = 100;
	this.masteryScore = 100;
 
	//liczniki        
	this._countQuestion = 0;
	this._countCorrectQuestion = 0;
	this._countAnswerQuestion = 0;

	this.pageScroll = null;
	this.pageType = "Information";
	this.isExam = false;
	this.name = "";  
	this.pageWidth = 800;
	this.pageHeight = 600;
  
	this.stepIndex = 0;
	this.expoType = 0;
	this.pageIndex = null; // Uzywany tylko przy komunikacji za pomoca AICC
//?	this.contentMode = lms.getUserValue("contentMode", 0);

	this.all = WBTObject.all;
	this.previewShowHiddenElements = true;
	this.prepareNextStep = true;
	this.stepsTimer = null;
	this.openStatus = lms.STATUS_NOT_ATTEMPTED;
	this.terminated = false;

	me = vars.init(config.meVars);
	vars.load(me, "me");
	sys = vars.init(config.sysVars);
	vars.load(sys, "sys");
};

componentPage.prototype = new WBTObject();
componentPage.prototype.type = "componentPage";

var psNormal=0;
var psDesigning=1;
var psPreview=2;
var psView=3;

componentPage.prototype.state = psNormal;

var firstWait = false;

componentPage.prototype.gotoPage = function(globalIndex, pageNum, pageIndex, pageName, projectName)
{
	return(lms.gotoPage(globalIndex, pageNum, pageIndex, pageName, projectName));
};

componentPage.prototype.onCreate = function()
{
	log.info("Location: " + location.href);
	
	for (var i = 0; i < this.children.length; i++) {
		if (this.children[i].isReady() == false) {
			setTimeout("page.onCreate()", 250);
			if (!firstWait) {
				firstWait = true;
			} else {  
				var waitlayer = document.getElementById("waitlayer");
				if (waitlayer) waitlayer.style.visibility = "inherit";
			}  
			return(0);
		}
	};
	
	if ((this.__wbtlinfo == 0 || this.__wbtlinfo == 2) && 
			(lms.name == "lmsScorm") &&
			(typeof(top.isWBTServer) == 'undefined')) {
		delete lms;
		lms = new dummyLMSManager();
	};

	// ukrywa warstwe "wait" z kodem html
	if (is.ie) {
		var waitlayer = document.getElementById("waitlayer");
		if (waitlayer) waitlayer.style.visibility = "hidden";
	}

	//
	this.style = (is.ns4) ? self : this.doc.body.style;
	this.obj = (is.ns4) ? self : this.doc.body;

	//
	this.style.backgroundColor = this.backgroundColor;
	this.style.backgroundImage = 'url(' + this.backgroundImage + ')';
	//page.style.bgProperties = this.backgroundFixed;

	// Load users functions (file UDFunctions.js).
	if (udf && udf.loadPage) udf.loadPage(this);

	if (this.pageType != 'Exercise') {
		lms.setPoints("");
	} else {
		var points = lms.getPoints();
		if(!points || points == "") {
			lms.setPoints("0");
		}
	}

	this.openStatus = lms.getStatus();
	
	if (lms.getStatus() == lms.STATUS_NOT_ATTEMPTED) lms.setStatus(lms.STATUS_INCOMPLETE);

	var l = this.children.length;
	for (var i = 0; i < l; i++) this.children[i].paint();
	for (var i = 0; i < l; i++) this.children[i].invokeEvent("PageReady");

	//odczytuje odpowiedz jaka udzielil user           
	if (page.state == psNormal && page.rememberAnswers) {
		if (lms.getStatus() == lms.STATUS_PASSED) {
			this.showCorrectAnswer();
		} else {
			var ans = lms.getLastUserAnswer();
			if (typeof(ans) == "string") {
				if (ans != "") {
					this.setAnswer(ans.split('#|#'));
				}
			}
		}
	};
	
	this.invokeEvent("Load");
	
	for(var i = 0; i < this.children.length; i++) {
		this.children[i].isCreated = true;
		this.children[i].actionOn = true;
	};
	
	lms.pageReady();
	
	if (this.state == psView || this.state == psNormal) {
		this.runSteps();
	}
	
//  this.obj.unselectable = "on";
	for (var i=0; i<this.children.length; i++) {
		this.children[i].unselectable();
	}
};

componentPage.prototype.onBeforeRemove = function()
{
	this.terminated = true;
	this.invokeEvent("UnLoad");
	//zapisuje odpowiedz jaka udzilil user           
	if (this.state == psNormal && page.rememberAnswers) {
		var ans = this.getAnswerString();
		// ten if jest tylko ze wzgledu na bd w WBTS ktry zanim wyjdzie ze strony
		// 15x robi jakie pier.one przeadowania !!!
		if (ans != "") lms.setLastUserAnswer(this.getAnswerString());
	}
	
	if (udf && udf.onBeforeRemove) udf.onBeforeRemove(this);
	
	vars.save(me, "me");
	vars.save(sys, "sys");
};

componentPage.prototype.onFree = function()
{
	log.info("componentPage.onFree");
	if (udf && udf.onFree) udf.onFree(this);
	this.stepsTimerStop();
	this.deleteAllChildren();
};

componentPage.prototype.showCorrectAnswer = function()
{
	for(var i=0; i<this.children.length; i++) {
		var child = this.children[i];
		if (child.setAnswer) {
			child.setAnswer(child.correctAnswer, true);
		}
	}
}


/* Steps */

componentPage.prototype.__initSteps = function()
{
	var comp_step = STEPS_HIDDEN;
	
	for(var i = 0; i < this.children.length; i++) {
		var comp_step = this.children[i].step;
		if (comp_step < 1) continue;
		if (comp_step >= this.stepsArray.length) {
			resizeIntegerArray(this.stepsArray, comp_step, 1000);
		}
	}
	
	// sprawdzamy czy krokw nie jest za wiele,
	// nadmiarowe kasujemy
	var maxstep = 0;
	for (var i = 0; i < this.children.length; i++) {
		if (this.children[i].step > maxstep) maxstep = this.children[i].step;
	}
	while (maxstep < page.stepsArray.length) this.stepsArray.pop();
	
	//przeniesienie elementow do ostatniego kroku
	for (var i=0; i<this.children.length; i++) {
		if (this.children[i].step == STEPS_LAST_STEP) {
			this.children[i].step = maxstep;
		}
	}
};

/*componentPage.prototype.__prevStep = function()
{ 

}*/

componentPage.prototype.__prepareStep = function(stepIndex)
{
	var allowNextStep = true;

	if (stepIndex < 0) return true;
	
	if (stepIndex < this.stepsArray.length) {
		for (var i=0; i<this.children.length; i++) {
			if ((this.children[i].step == stepIndex) 
				&& ((this.children[i].type == "componentAudio") || (this.children[i].type == "componentVideo"))
				&& (this.children[i].nextStepWaitToEnd == true)) {
				allowNextStep = this.children[i].allowNextStep;
				if (!allowNextStep) break;
			}
		}
	}
	
	return allowNextStep;
}

componentPage.prototype.__nextStep = function()
{
	this.stepsTimerStop();
	
	if (this.__prepareStep(this.stepIndex - 1) == false) {
		this.stepsTimerRun(250);
		return;
	}
	
	if (!this.prepareNextStep) return;
	this.prepareNextStep = false;
	
	// uruchamia funkcje parenta "updateSteps", o ile ta istnieje
	// Funkcja ma na celu zaktulizowanie informacji o tym na ktorym 
	// aktualnie kroku jestesmy
	if (parent.updateSteps) parent.updateSteps(this.stepIndex, this.stepsArray.length);
	
	for (var i=0; i<this.children.length; i++) {
		if (this.children[i].step == this.stepIndex) {
			
//			var stepGo = true;
//			if (page.children[i].stepIf && page.children[i].stepIf != "") {
//				stepGo = eval(unescape(page.children[i].stepIf)) == true;
//			}
			
			if (this.stepIndex >= 0 /*&& stepGo*/) this.children[i].Step();
			if (this.terminated) return;
		}
	}
	
	if (this.stepIndex < this.stepsArray.length) {
		if (this.stepsTimer == null) {
			this.stepsTimerRun();
		} else {
			this.stepsTimerStop();
			this.stepsTimerRun();
		}
		this.stepIndex++;
		this.prepareNextStep = true;
	} else {
		this.stepsTimerStop();
		var status = lms.getStatus();
		if (status == lms.STATUS_INCOMPLETE || status == lms.STATUS_NOT_ATTEMPTED) lms.setStatus(lms.STATUS_COMPLETED);
	}
}

componentPage.prototype.prevStep = function()
{
	//this.__prevStep();
}

componentPage.prototype.nextStep = function()
{
	if (this.stepsTimer != null) {
		this.stepsTimerStop();
		
		for (var i=0; i<this.children.length; i++) {
			if (this.children[i].step == this.stepIndex - 1) {
				if (this.children[i].stop) this.children[i].stop();
			}
		}
		
		this.__nextStep();
	}
}

componentPage.prototype.backwards = function()
{
	this.prevPage();
}

componentPage.prototype.further = function()
{
	if (this.stepsTimer == null) this.nextPage();
	else {
		var count = 0;
		this.stepsTimerStop();
		
		for (var i=0; i<this.children.length; i++) {
			if (this.children[i].step == this.stepIndex - 1) {
				if (this.children[i].stop) this.children[i].stop();
			}
		}
			
		for (var i=this.stepIndex; i<this.stepsArray.length; i++) {
			for (var j=0; j<this.children.length; j++) {
				if (this.children[j].step == this.stepIndex) count++;
			}
			if (count > 0) break;
			else this.stepIndex++;
		}
		
		this.__nextStep();
	}
}

componentPage.prototype.goToChosenStep = function(step) {
	step = parseInt(step);
	
	if (step <= this.stepsArray.length) {
		this.stepsTimerStop();
		
		if (step > this.stepIndex) {
			for (var i=this.stepIndex; i<step; i++) {
				this.stepIndex = i;
				if (parent.updateSteps) parent.updateSteps(this.stepIndex, this.stepsArray.length);
				
				for (var j=0; j<this.children.length; j++) {
					if (this.children[j].step == i) {
						this.children[j].Step();
						if (this.children[j].stop) this.children[j].stop();
					}
				}
			}
			
			this.stepIndex = step;
			this.__nextStep();
		}
	}
};

componentPage.prototype.stepsTimerRun = function(interval) {
	if (this.stepsTimer == null) {
		if (interval) this.stepsTimer = window.setTimeout("page.__nextStep()", parseInt(interval));
		else this.stepsTimer = window.setTimeout("page.__nextStep()", parseInt(this.stepsArray[this.stepIndex]));
	}
};

componentPage.prototype.stepsTimerStop = function() {
	if (this.stepsTimer != null) {
		window.clearTimeout(this.stepsTimer);
		this.stepsTimer = null;
	}
};

componentPage.prototype.runSteps = function()
{
	this.__initSteps();
	this.__nextStep();
};

function resizeIntegerArray(arr,newLength,defaultValue)
{
	var i;
	if (arr.length <= newLength) {
		for (i=arr.length;i<newLength+1;i++) {
			arr[i]=defaultValue;
		}
	}
};

/********************************************************************/

componentPage.prototype.setSize = function( w, h )
{
	this.pageWidth = w;
	this.pageHeight = h;
};

componentPage.prototype.setTryCount = function( i )
{
	this.countAnswers = i;
};

componentPage.prototype.setIsExam = function( b )
{
	this.isExam = b;
};

componentPage.prototype.setName = function( s )
{
	this.name = s;
	this.setID(s);
};

componentPage.prototype.setPageIndex = function( i )
{
	this.pageIndex = i;
};

componentPage.prototype.hideFeedbacks = function()
{
	if (this.pageType == "Exercise") {
		var feedback = this.findChildByName(this.feedbackOkName);
		if (typeof(feedback) != "undefined") feedback.setVisible(false);
		feedback = this.findChildByName(this.feedbackBadName);
		if (typeof(feedback) != "undefined") feedback.setVisible(false);
		feedback = this.findChildByName(this.feedbackLastBadName);
		if (typeof(feedback) != "undefined") feedback.setVisible(false);
		feedback = this.findChildByName(this.feedbackNotOkName);
		if (typeof(feedback) != "undefined") feedback.setVisible(false);
	}
}

componentPage.prototype.shObjects = function(objectType, sh) 
{
	var shBool = (sh == "true");
	
	for (var i=0; i<this.children.length; i++) {
		if (this.children[i].isComponentElement && this.children[i].type == objectType) {
			if (shBool) {
				if (this.children[i].actionRun) this.children[i].actionRun();
				else if (this.children[i].actionMediaPlay) this.children[i].actionMediaPlay();
				else this.children[i].setVisible(shBool);
			} else {
				if (this.children[i].actionStop) this.children[i].actionStop();
				else if (this.children[i].actionMediaStop) this.children[i].actionMediaStop();
				else this.children[i].setVisible(shBool);
			}
		}
	}
};

componentPage.prototype.rsObjects = function(objectType, rs) 
{
	this.shObjects(objectType, rs)
};

componentPage.prototype.shChosenObjects = function(chosenObjects, sh)
{
	if (chosenObjects == null || chosenObjects == "" || sh == null || sh == "") return;
	
	chosenObjects = unescape(chosenObjects);
	var shBool = (sh == "true");
	var chosenObjectsArr = new Array();
	chosenObjectsArr = chosenObjects.split("|");
	
	for (var i=0; i<this.children.length; i++) {
		for (var j=0; j<chosenObjectsArr.length; j++) {
			if (this.children[i].isComponentElement && this.children[i].id == chosenObjectsArr[j]) {
				if (shBool) {
					if (this.children[i].actionRun) this.children[i].actionRun();
					else if (this.children[i].actionMediaPlay) this.children[i].actionMediaPlay();
					else this.children[i].setVisible(shBool);
				} else {
					if (this.children[i].actionStop) this.children[i].actionStop();
					else if (this.children[i].actionMediaStop) this.children[i].actionMediaStop();
					else this.children[i].setVisible(shBool);
				}
			}
		}
	}
};

componentPage.prototype.setExercisePassed = function(points)
{
	lms.setStatus(lms.STATUS_PASSED);
	lms.setPoints(points);
}

componentPage.prototype.setExerciseFailed = function(points)
{
	lms.setStatus(lms.STATUS_FAILED);
	lms.setPoints(points);
}

componentPage.prototype.showFeedbackOk = function(answer)
{
	this.hideFeedbacks();
	if (this.answerWeighting && answer < this.maxScore) {
		var e = this.findChildByName(this.feedbackOkName);
	} else {
		var e = this.findChildByName(this.feedbackOkName);
	}
	if(this.feedbacksShow && e) {
		e.setVisible(true);
	}
	return true;
}

componentPage.prototype.showFeedbackBad = function(answer)
{
	this.hideFeedbacks();
	var e = this.findChildByName(this.feedbackBadName);
	if (this.feedbacksShow && e) {
		e.setVisible(true);
	}
	return true;
}

componentPage.prototype.showFeedbackLastBad = function(answer)
{
	this.hideFeedbacks();
	var e = this.findChildByName(this.feedbackLastBadName);
	if (this.feedbacksShow && e) {
		e.setVisible(true);
	}
	return true;
}

componentPage.prototype.showFeedbackNotOk = function(answer)
{
	this.hideFeedbacks();
	var e = this.findChildByName(this.feedbackNotOkName);
	if (this.feedbacksShow && e) {
		e.setVisible(true);
	}
	return true;
}

componentPage.prototype.countAnswer = function()
{
	this.countAnswers--;
		
	this._countQuestion = 0;
	this._countCorrectQuestion = 0;
	this._countAnswerQuestion = 0;
	//leci po wszystkich zarejestrowanych komponentach
	//i wywoluje funkcje answer
	for(var i = 0; i < this.children.length; i++) {
		if (this.children[i].isComponentElement && this.children[i].checkAnswer && this.children[i].visible) {
			var ansVal = this.children[i].checkAnswer();
			if (this.children[i].clearIncorectAnswer) {
				this.children[i].invokeEvent("Clear");
			}
			if (!this.children[i].ignoreAnswer && !this.children[i].checkLock) {
				this._countQuestion++;
				if (ansVal == true ) {
					this._countCorrectQuestion++;
				}
			}
			
			if (this.children[i].checkIsAnswer && (this.children[i].checkIsAnswer() == true)) {
				this._countAnswerQuestion++;
			}
		} // IF(...)
	} // FOR(...)
	//obliczenie procentowe odpowiedzi 100 oznacza 100% wysztko ok
	//im mniej od 100 tym bardziej do bani
	ans = Math.floor((this.maxScore / this._countQuestion) * this._countCorrectQuestion);
	
	return ans;
}

componentPage.prototype.showAnswer = function(answer)
{
	var corAns = (this.answerWeighting)?(answer >= this.masteryScore):(answer == this.maxScore);
	if (!corAns && !this.answerWeighting) answer = 0;
	if (corAns && !this.answerWeighting) answer = this.maxScore;
	//przed feedbackami
	if (this.countAnswers < -1) this.countAnswers = -1;
	
	if (this.countAnswers <= 0) {
		if (corAns) {
			this.invokeEvent("BeforePageCorrectAnswer");
		} else {
			this.invokeEvent("BeforePageIncorrectAnswer");
		}
	}
	// show pops
	if (this.countAnswers > 0) { 
		if (corAns) {
			this.showFeedbackOk(answer);
			this.setExercisePassed(answer);
		} else {
			this.showFeedbackBad(answer);
			this.setExerciseFailed(answer);
		}
	} else {
		if (corAns) {
			this.showFeedbackOk(answer);
			this.setExercisePassed(answer);
		} else { 
			this.showFeedbackLastBad(answer);
			this.setExerciseFailed(answer);
		}
	}
	//po feedbackach
	if (this.countAnswers <= 0) {
		if (corAns) {
			this.invokeEvent("AfterPageCorrectAnswer");      
		} else {
			this.invokeEvent("AfterPageIncorrectAnswer");
		}
	}
	
	return true;
}

componentPage.prototype.checkAnswer = function(obj)
{
	var udChAns = 0;
	
	if (udf.checkAnswers) udChAns = udf.checkAnswers(this, obj);
	
	if (udChAns == E_NOTIMPL) {
		if (!this.isExam) {
			
			var ans = this.countAnswer();
			var udRes = 0;
			
			if (udf.countAnswer) udRes = udf.countAnswer(this);
			if (udRes != E_NOTIMPL) ans = udRes;
			
			var corAns = (this.answerWeighting) ? (ans >= this.masteryScore) : (ans == this.maxScore);
			if (corAns) this.countAnswers = 0;
			
			if (this.countAnswers == 0) {
				//rozeslanie akcji
				this.sendAnswerEvent();
				//blokada 
				if (obj && obj.isComponentElement) {
					obj.setVisible(false);
					this.lockElements();
				}
			}
			
			if (udf.showAnswer) udRes = udf.showAnswer(this, ans);
			if (udRes == E_NOTIMPL) {
				this.showAnswer(ans);
			}
			
		} else {
			lms.checkAnswer();
		}
		
		this.invokeEvent("CheckAnswer");
		
		// zwraca wartosc:
		//	'1' jesli zadanie zostalo rozwiazane;
		//	'0' kiedy zadanie zostalo zle rozwiazane, lub na stronie nie bylo zadania;
		
		if (this._countQuestion == 0) return 0;
		if (this._countCorrectQuestion == this._countQuestion) return 1;
		else return 0;
	}
	return udChAns;
};

/**
 * rozsyla zdarzenia po komponentach
 **/
componentPage.prototype.sendAnswerEvent = function()
{
	for(var i = 0; i < this.children.length; i++) {
		if (this.children[i].isComponentElement && this.children[i].checkAnswer && this.children[i].visible) {
			if (this.children[i].checkAnswer()) {
				this.children[i].invokeEvent("CorrectAnswer");
			} else {
				this.children[i].invokeEvent("IncorrectAnswer");
			}
		}
	}
};  
      
componentPage.prototype.lockElements = function()
{
	for (var i=0; i<this.children.length; i++) {
		this.children[i].lock();
		/*if (this.grayElementsWhenLocked == true || this.grayElementsWhenLocked == "true") {
			var child = this.children[i];
			child.filters.gray=true;
		}*/
	};
};

componentPage.prototype.unlockElements = function()
{
	for(var i=0; i<page.children.length; i++) {
		page.children[i].invokeEvent("UnLock");
	}
};

/**
 * Pobierz zmienna uytkownika.
 */
componentPage.prototype.getUserValue = function(name)
{
	return me[name];
	//return(lms.getUserValue(name));
};

/**
 * Ustaw zmienna uytkownika. Zmienna dostpna na wszystkich stronach.
 */
componentPage.prototype.setUserValue = function(name, value)
{
	me[name] = value;
	//lms.setUserValue(name, value);
};

componentPage.prototype.getValue = function(name)
{
	return(lms.getValue('_' + this.pageIndex + name));
};

componentPage.prototype.setValue = function(name, value)
{
	lms.setValue('_' + this.pageIndex + name, value);
};

componentPage.prototype.getAnswer = function()
{
	var answer = new Array();
	var ai = 0;
	for(var i=0; i<page.children.length; i++) {
		if (page.children[i].getAnswer) {
			answer[ai++] = page.children[i].getAnswer();
		}
	}
	return answer;
};

componentPage.prototype.getAnswerString = function(sep)
{
	var answer = page.getAnswer();
	var sendAnswer = '';
	if (sep == null) sep = '#|#';
	for (var i=0; i<answer.length; i++) sendAnswer += answer[i] + sep;
	
	return(sendAnswer);
};

componentPage.prototype.setAnswer = function(answer)
{
	var ai = 0;
	for(var i=0; i<page.children.length; i++) {
		if (page.children[i].setAnswer) {
			page.children[i].setAnswer(answer[ai++]);
		}
	}
};

componentPage.prototype.actionCheckAnswer = function()
{
	this.checkAnswer();
};

componentPage.prototype.setPageType = function(pageType)
{
	this.pageType = pageType;
};

componentPage.prototype.findChildByPosAndType = function(x, y, type)
{
	var obj = null;
	for(var i=0; i<this.children.length; i++) {
		var child = this.children[i];
		if (x >= child.x && x <= child.x + child.w &&
			y >= child.y && y <= child.y + child.h && type == child.type) {
			if ((!obj) || (obj && child.z > obj.z)) obj = child;
		}
	}
	return(obj);
};

componentPage.prototype.openDialog = function(url, w, h, toolbar, menubar, status, scrollbars, resizable)
{
	return(openDialog(url, w, h, toolbar, menubar, status, scrollbars, resizable));
};

componentPage.prototype.mediaAlert = function(w, h, chb)
{
	return(openDialog(mediaAlert.html, w, h));
};

//--do przerobienia
componentPage.prototype.setContentMode = function(i)
{
	sys.contentMode = i;
};

componentPage.prototype.nextPage = function()
{
	lms.nextPage();
}

componentPage.prototype.prevPage = function()
{
	lms.prevPage();
}

var resourcesURL = '';
var page = new componentPage();

/********************************************************************/        

var sProtoWBTRes = 'wbtres://';
var dialogWin = "";

function validateURL(url) 
{
	if (url.substr(0,sProtoWBTRes.length).toLowerCase() == sProtoWBTRes) {
		return(resourcesURL + url.substr(9,url.length));
	}
	return(url);
};

function __checkModal() {
   setTimeout("__finishChecking()", 50)
   return true
}

function __finishChecking() {
	if (dialogWin != null && !dialogWin.closed) {
		dialogWin.win.focus() 
	} else {
		window.onfocus = null;
	}
}

function openDialog(url, w, h, toolbar, menubar, status, scrollbars, resizable)
{
	var x = (screen.width/2)-(w/2);
	var y = (screen.height/2)-(h/2);
	
	var opt = 'location=no, personalbar=no, directories=no';
	opt += (toolbar != null) ? ', toolbar=' + toolbar :'';
	opt += (menubar != null) ? ', menubar=' + menubar :'';
	opt += (status != null) ? ', status=' + status :'';
	opt += (scrollbars != null) ? ', scrollbars=' + scrollbars :'';
	opt += (resizable != null) ? ', resizable=' + resizable :'';
	opt += (x != null) ? ', left=' + x:'';
	opt += (y != null) ? ', top=' + y:'';
	opt += (w != null) ? ', width=' + w:'';
	opt += (h != null) ? ', height=' + h:'';
	dialogWin = window.open(unescape(validateURL(url)), '', opt);
	dialogWin.focus();
	window.onfocus = __checkModal;
	return(dialogWin);
};

function openWindow(url, options)
{
	return(window.open(validateURL(url), '', options));
};

function calculateTime(timeStart, timeEnd, format)
{
	var dd = Math.abs(timeEnd.getTime() - timeStart.getTime());
	var ts = Math.floor((((dd % (60 * 60 * 1000 * 24)) % (60 * 60 * 1000)) % (60 * 1000)) / 1000 * 1);
	var tm = Math.floor(((dd % (60 * 60 * 1000 * 24)) % (60 * 60 * 1000)) / (60 * 1000) * 1);
	var th = Math.floor((dd % (60 * 60 * 1000 * 24)) / (60 * 60 * 1000) * 1);
	
	switch(format) {
		case "ms":
			var m = (tm + th * 60);
			var sm = ((m < 10) ? "0" : "") + m;
			var ss = ((ts < 10) ? "0" : "") + ts;
			return(sm+':'+ss);
			break;
		case "s":
			return ((th*60*60) + (tm*60) + ts);
			break;  
		default:
			var sh = ((th < 10) ? "0" : "") + th;
			var sm = ((tm < 10) ? "0" : "") + tm;
			var ss = ((ts < 10) ? "0" : "") + ts;
			return(sh+':'+sm+':'+ss);
	}
	return('');
}


/********************************************************************/        

<!--DSFunctions.js-->

/*********************************************************************
**
** Old Functions
**
*********************************************************************/

function getFileNameFromPath(path)
{
	while(path.indexOf('/')>-1) {
		path=path.substring(path.indexOf('/')+1,path.length);
	}
  return path;
}

function getPageDirFromPath(path){
	path = path.substring(0, path.lastIndexOf('/'));
	path = path.substring(path.lastIndexOf('/') + 1, path.length);
	return path;
}

// ****************************************************************
function getVideoPath(fullpath){                  
	if ((!parent) && ((!parent.dsBrowser) || (!parent.isWBTServer))) return fullpath;
	if (parent.videoSelected){
		var videoSelected = parent.videoSelected;
		if (videoSelected == "off") {
			path = "OFF";
		} else if (videoSelected == "online") {
			path = fullpath;
		} else if (videoSelected == "offline") {
			if ((parent.pathToVideos) != null) {
				path = parent.pathToVideos+'/'+getPageDirFromPath(""+document.location)+'/'+getFileNameFromPath(fullpath);
			}
		}                                
		return path;
	} else {
		var videoSelected = cookie.get("videoSelected");        
		if (videoSelected == "off") {
			path = "OFF";
		} else if (videoSelected == "online") {
			path = fullpath;
		} else if (videoSelected == "offline") {
			if (cookie.get("pathToVideos") != null) {
				path = cookie.get("pathToVideos") + '/' + getPageDirFromPath("" + document.location)
					+ '/' + getFileNameFromPath(fullpath);
			}
		} else path = fullpath;
		return path;
	}
}

//-------------------------------------
// Function gets element type "moveable". It can be moved
//-------------------------------------
function getParent(element)
{
	temp = element;
	while ((temp != null) && (temp.tagName != "BODY")) {
		if (temp.className == "moveable") {
			element = temp;
			return element;
		} else {
			temp = temp.parentElement;
		}
	}
	return element;
};

function getParentDiv(element)
{
	temp = element;
	while ((temp != null) && (temp.tagName != "BODY")) {
		if (temp.tagName == "DIV") {
			element = temp;
			return element;
		} else {
			temp = temp.parentElement;
		}
	}
	return element;
};

function setOnTop(element)
{
	max = 0;
	tmp = document.all;
	for (i=0;i<tmp.length;i++) {
		if ((tmp[i].style.zIndex > max) && (tmp[i].className == "moveable")) max = tmp[i].style.zIndex;
	}
	element.style.zIndex = max + 2;
};

//-------------------------------------------
// Array management functions
//-------------------------------------------
function push(arrName,element)
{
	var i = arrName.length;
	arrName[i] = element;
};

function pushArrays(arrName,arrValue,element1,element2)
{
	var i = arrName.length;
	var j = arrValue.length;
	arrName[i] = element1;
	arrValue[j] = element2;
};


function getValueFromArray(arrName,arrValue,element)
{
	var i=0;
	for (i=0;i<arrName.length;i++) {
		if (arrName[i] == element) return arrValue[i];
	}
};

function pop(arrName,element)
{
	var i=0;
	var newArr = new Array();
	for (i=0;i<arrName.length;i++) {
		if (arrName[i] != element) push(newArray,arrName[i]);
	}
	return newArr;
};

function actionHideObject(objectName)
{
	elements = document.all;
	
	if (elements['div_'+objectName]) {
		if (elements['div_'+objectName].tagName == 'DIV') {
			elements['div_'+objectName].style.setAttribute("visibility","hidden","false");
			return false;   
		}
	}
};

function actionShowObject(objectName)
{
	elements = document.all;
	if (elements['div_'+objectName]) {
		if (elements['div_'+objectName].tagName == 'DIV') {
			elements['div_'+objectName].style.setAttribute("visibility","visible","false");
			return false;   
		}
	}
};

function getIndex(arrayName,objectName,idx)
{
	if (idx+1 >= arrayName.length) return -2;
	for (x=idx+1;x<arrayName.length;x++) {
		//if (objectName == 'div_'+arrayName[x] )
		if (objectName.indexOf('div_'+arrayName[x])==0){
			return x;
		}
	}
	return -2;
};

function makeAmpersand(s)
{
	if (s.charAt(0) != '"') s = '"'+s+'"';
	return s;
}        

function onClickObject(object)
{
	if (!object) return false;
	elements = document.all;
	index = -1;
	window.status = object.id;
	
	if (elements[object.id]) {
		if (elements[object.id].tagName == 'DIV') {
			index = getIndex(onClickObjects,object.id,index);
			while (index > -2) {
				if (index > -2) { 
					action = onClickActions[index]+"("+makeAmpersand(onClickParams[index])+")";
					eval(action);
					//return true;
				}
				index = getIndex(onClickObjects,object.id,index);
			}
			return false;
		}
	}
	return false;
};

function onMouseOverObject(object)
{
	object = getParentDiv(event.srcElement);   
	if (!object) return false;
	elements = document.all;
	index = -1;
	window.status = object.id;
	
	if (elements[object.id]) {
		if (elements[object.id].tagName == 'DIV') {
			index = getIndex(onMouseOverObjects,object.id,index);
			while (index > -2) {
				if (index > -2) { 
					action = onMouseOverActions[index]+"("+makeAmpersand(onMouseOverParams[index])+")";
					eval(action);
				}
				index = getIndex(onMouseOverObjects,object.id,index);
			}
			return false;
		}   
	}
	return false;
};

function onMouseOutObject(object)
{
	object = getParentDiv(event.srcElement);   
	if (!object) return false;
	elements = document.all;
	index = -1;
	window.status = object.id;
	
	if (elements[object.id]) {
		if (elements[object.id].tagName == 'DIV') {
			index = getIndex(onMouseOutObjects,object.id,index);
			while (index > -2) {
				if (index > -2) {
					action = onMouseOutActions[index]+"("+makeAmpersand(onMouseOutParams[index])+")";
					eval(action);
				}
				index = getIndex(onMouseOutObjects,object.id,index);
			}
			return false;
		}   
	}
	return false;
};

// Radio handling function
var resetRadioFunctions = new Array();

function resetRadios(obj)
{
	var groupName=''+obj.substr(obj.indexOf('_g_'),obj.length);
	var i = 0;
	var count = resetRadioFunctions.length;
	for (i=0;i<count;i++) {
		var cnt = i;
		var fn = resetRadioFunctions[cnt];
		if (fn.indexOf(groupName)>-1) eval(fn);
	}
};

// Form checking and changing functions
var formFieldNames = new Array();
var formCorrectAnswers = new Array();

function actionChangeFieldValue(fieldname,state)
{
	document.forms['pageForm'].elements[fieldname].value = state;
};

//start MK: ******************************************************************************
// audio video functions
var videoObjects = new Array();
var videoFileNames = new Array();
function actionPlay(which) {
	var orygVideopath=getValueFromArray(videoObjects,videoFileNames,which);                                                                
	var videopath = getVideoPath(orygVideopath);
	if (videopath!="OFF") {
	if (videopath != orygVideopath) eval("media_"+which+".FileName = videopath");
		showTextToMedia(which);
		eval("media_" + which + ".play();");                        
	} else {
		// here show image instead of video:
		actionShowObject ("img_video");
		actionHideObject ("video1");
	}
};
//end MK: ******************************************************************************

function actionStop(which) 
{
	eval("media_" + which + ".stop();");
};

function actionPause(which) 
{
	if (eval("media_" + which + ".SendPlayStateChangeEvents")) {
		if (eval("media_" + which + ".PlayState==1"))  {
			eval("media_" + which + ".play();")
		} else {
			eval("media_" + which + ".Pause();")
		}
	}
};

// other functions
var ObjNames = new Array();
var ObjValues = new Array();

// show correct answer 
function actionShowAnswer(obj)
{
	if (showAnswers) {
		var _obj = eval('div_CorrAns_' + obj);
		if (_obj) {
			setOnTop(_obj);
			_obj.style.setAttribute("left", window.event.clientX + 10, "false");
			_obj.style.setAttribute("top", window.event.clientY - 10, "false");
			actionShowObject('CorrAns_' + obj);
		}
	}
};

//-------------------------------------------
// Opens lexicon and sets it to selected keyword
//-------------------------------------------

function openLexicon(path, keyword)
{
	if (lms.useExternalLexicon()) {
		lms.callExternalLexicon(keyword);
	} else {
		window.open(path + 'lexicon.html?keyword=' + keyword, '', 'width=640,height=420');
	}
	return;
};

function checkIsScenario() {
	str = '' + document.location;
	if (str.indexOf('scenario=true')>0) isScenario=true;
};

function setDSTimeout(action, object, time) {
	if (isScenario) time=0;
	var timeAction = 'setTimeout(\"' + action + '(\'' + object + '\')\"' + ',' + time + ')';
	//alert(timeAction);
	eval(timeAction);
};

componentPage.prototype.createScrollLayer=function(contentText) 
{
	this.pageScroll=new newScrollLayer(10,550,780, 50, resourcesURL+"___.media.scroller",12,12,contentText);
}

function setScrollText(text){
	if (text==null) return false;
	if (text=='') return false;
	if (pageScroll!=null) {
		pageScroll.setContent(text);        
		pageScroll.setThumbPos(pageScroll.maxThumb);
		pageScroll.showScrollbar(true);
	}
}

componentPage.prototype.addScrollText=function(text)
{
	if (text == null || text == "") return false;
	
	if (this.pageScroll == null) {
		this.pageScroll = new newScrollLayer(10,550,780, 50, resourcesURL+"___.media.scroller",12,12,'');
	}
	if (this.pageScroll != null) {
		this.pageScroll.addContent(text);
		this.pageScroll.setThumbPos(this.pageScroll.maxThumb);
		this.pageScroll.showScrollbar(true);
	}
}

function showScroll() {
	if (pageScroll!=null) pageScroll.showScrollbar(true);
}

function hideScroll() {
	if (pageScroll!=null) pageScroll.showScrollbar(false);
}

function newScrollLayer(nLeft, nTop, nWidth, nHeight, imagePath, buttonWidth, buttonHeight,contentText) {
	this.id = newScrollLayer.instanceNr++;
	newScrollLayer.layers[this.id] = this;
	this.objectName = 'newScrollLayer.layers['+this.id+']';
	this.imagePath = imagePath;
	this.left = nLeft;
	this.top = nTop;
	this.width = nWidth;
	this.height = nHeight;
	this.scrollOffset = 0;
	this.buttonWidth = buttonWidth?buttonWidth:16;
	this.buttonHeight = buttonHeight?buttonHeight:16;
	this.timer = 0;
	this.content = '';
	this.thumbDown = true;
	this.maxThumb = this.height - 3 * this.buttonHeight;
	this.thumbOffset = 0;
	this.layer = createLayer('scroller'+this.id, null, this.left, this.top, this.width, this.height,'', null, 'inherit', 100);  
	if (this.layer.style) this.layer.style.overflow = "hidden";  
	this.contentLayer = createLayer('content'+this.id, 'scroller'+this.id, 0, 0, this.width-this.buttonWidth,null,contentText, null, 'visible', 1);
	var downBtn = '<img src="'+imagePath+'down0.gif" width="'+this.buttonWidth+'" height="'+this.buttonHeight+'">';
	var upBtn =  '<img src="'+imagePath+'up0.gif" width="'+this.buttonWidth+'" height="'+this.buttonHeight+'">';
	var thumbBtn = '<img src="'+imagePath+'thumb.gif" width="'+this.buttonWidth+'" height="'+this.buttonHeight+'">';
	var nothingBtn = '<img src="'+imagePath+'nothing.gif" name="nix" width="'+this.buttonWidth+'" height="'+this.height+'">';
	this.down = createLayer('scrollerdown'+this.id, 'scroller'+this.id, this.width - this.buttonWidth, this.height - this.buttonHeight, this.buttonWidth, this.buttonHeight, downBtn, null, 'inherit', 2);
	this.up = createLayer('scrollerup'+this.id, 'scroller'+this.id, this.width - this.buttonWidth, 0, this.buttonWidth, this.buttonHeight, upBtn, null, 'inherit', 2);
	this.thumb = createLayer('thumb'+this.id, 'scroller'+this.id, this.width - this.buttonWidth, this.buttonHeight, this.buttonWidth, this.buttonHeight, thumbBtn, null, 'inherit', 2);
	this.nothinglayer = createLayer('nothing'+this.id, 'scroller'+this.id, this.width - this.buttonWidth, 0, this.buttonWidth, this.height, nothingBtn, null, 'inherit', 3);    
	this.hrtop = createLayer('hrtop'+this.id,null, this.left,this.top-10, this.width,8,'<HR>', null, 'visible', 4);
	this.setContentPos = sl_setContentPos;
	this.setContentPosIntern = sl_setContentPosIntern;
	this.setThumbPos = sl_setThumbPos;
	this.setThumbPosIntern = sl_setThumbPosIntern;
	this.scroll = sl_scroll;
	this.setContent = sl_setContent;
	this.addContent = sl_addContent;
	this.getContent = sl_getContent;
	this.onThumbMove = sl_onThumbMove;
	this.onThumbDown = sl_onThumbDown;
	this.onThumbUp = sl_onThumbUp;
	this.update = sl_update;
	this.showScrollbar = sl_showScrollbar;  
	routeLayerEvent(this.nothinglayer, 'onmousemove', this.objectName+".onThumbMove");
	routeLayerEvent(this.nothinglayer, 'onmousedown', this.objectName+".onThumbDown");
	routeLayerEvent(this.nothinglayer, 'onmouseup', this.objectName+".onThumbUp");
	routeLayerEvent(this.nothinglayer, 'onmouseout', this.objectName+".onThumbUp");    
	this.update();    
	this.setThumbPos(this.maxThumb);
	this.showScrollbar(false);
}

newScrollLayer.instanceNr = 0;
newScrollLayer.layers = new Array();

function routeLayerEvent(layerObj, eventName, handler, params) {
	layerObj[eventName] = new Function(handler+"(window.event.offsetX,window.event.offsetY);return false;");
}

function sl_update() {
	this.contentHeight = this.contentLayer.offsetHeight;
	this.maxScrollOffset = Math.max(this.contentHeight-this.height, 0);
	if (this.maxScrollOffset == 0) this.showScrollbar(false);
	else this.showScrollbar(true);
	this.setContentPos(this.scrollOffset);
}

function sl_setContent(newContent) {
	this.content = newContent;
	setLayerText(this.contentLayer, newContent);
	this.update();
}

function sl_addContent(newContent) {
	this.content = newContent;
	addLayerText(this.contentLayer, newContent);
	this.update();
}

function sl_getContent() {
	return this.content;
}

function sl_setContentPos(newPos) {
	this.setContentPosIntern(newPos);
	if (this.maxScrollOffset > 0) {
		this.setThumbPosIntern(Math.round(this.maxThumb * newPos / this.maxScrollOffset));
	}
}

function sl_setContentPosIntern(newPos) {
	if (newPos < 0) newPos = 0;
	if (newPos > this.maxScrollOffset) newPos = this.maxScrollOffset;
	this.scrollOffset = newPos;
	this.contentLayer.style.top = -this.scrollOffset;
}

function sl_scroll(delta) {
	this.setContentPos(this.scrollOffset + delta);
}

function sl_onThumbDown(x,y) {
	if (y <= this.buttonHeight) {
		this.scroll(-5);
		if (this.timer == 0)
			this.timer = window.setInterval(this.objectName+".onThumbDown("+x+","+y+")", 50);
	} else if (y >= this.height-this.buttonHeight) {
		this.scroll(5);
		if (this.timer == 0)
			this.timer = window.setInterval(this.objectName+".onThumbDown("+x+","+y+")", 50);
	} else {
		this.thumbDown = true;
		this.oldy = -1;
	}
}

function sl_onThumbUp(x,y) {
	if (this.timer != 0) {
		clearInterval(this.timer);
		this.timer = 0;
	}
	this.thumbDown = false;
}

function sl_setThumbPos(newPos) {
	this.setThumbPosIntern(newPos);
	this.setContentPosIntern( Math.round(this.maxScrollOffset * (this.thumbOffset / this.maxThumb)) );
}

function sl_setThumbPosIntern(newPos) {
	if (newPos < 0) newPos = 0;
	if (newPos > this.maxThumb) newPos = this.maxThumb;
	this.thumbOffset = newPos;
	this.thumb.style.top = this.buttonHeight + this.thumbOffset;
}

function sl_onThumbMove(x,y) {
	if (this.thumbDown) {
		if (this.oldy > 0) {
			var newThumby = this.thumbOffset + y - this.oldy;
			this.setThumbPos(newThumby);
		}
		this.oldy = y;
	}
}

function createLayer(id,nestref,left,top,width,height,content,bgColor,visibility,zIndex) {
	var lyr;
	var str = '\n<DIV id='+id+' style="position:absolute; left:'+left+'; top:'+top+'; width:'+width;
	if (height!=null) {
		str += '; height:'+height;
		str += '; clip:rect(0,'+width+','+height+',0)';
	}
	if (bgColor!=null) str += '; background-color:'+bgColor;
	if (zIndex!=null) str += '; z-index:'+zIndex;
	if (visibility) str += '; visibility:'+ visibility;
	str += ';">';
	if (content) str +=content;
	str +='</DIV>';
	if (nestref) {
		index = nestref.lastIndexOf(".");
		var nestlyr = (index != -1)? nestref.substr(index+1) : nestref;
		document.all[nestlyr].insertAdjacentHTML("BeforeEnd",str);
	}else {
		document.body.insertAdjacentHTML("BeforeEnd",str);
	}
	lyr = getObject2(id);        
	return lyr;
}

function getObject2(r, d) {  
	var p,n,i,x;  
	if (!d) d=document;
	n=r.substring(r.lastIndexOf(".")+1);
	if (n.indexOf("layers[")==0) n=n.substring(8,n.length-2);
	if (parent.frames.length) { 
		if (r.indexOf(".frames[")==6) 
		d=eval(r.substring(0,r.indexOf("]")+10));
		if ((p=r.indexOf("?"))!=-1) {
			n=r.substring(0,p); 
			d=parent.frames[r.substring(p+1)].document;
		}
	}
	if (!(x=d[n])&&d.all) x=d.all[n]; 
	for (i=0;!x&&i<d.forms.length;i++) x=d.forms[i][n];
	for (i=0;!x&&d.layers&&i<d.layers.length;i++) x=getObject2(n,d.layers[i].document); return x;
}

function setLayerText(aLayer, aText) {
	if (typeof(aLayer)=='string') aLayer = getObject2(aLayer);
	if (aLayer) {
		aLayer.innerHTML = aText;        
	}        
}


function addLayerText(aLayer, aText) {
	if (typeof(aLayer)=='string') aLayer = getObject2(aLayer);
	if (aLayer) {
		if (aLayer.innerHTML=='') aLayer.innerHTML=aText;
		else aLayer.innerHTML +='<BR>--------------------<BR>' +aText;
	}        
}

function setLayerVisible(aLayer, aState) {
	if (typeof(aLayer)=='string') aLayer = getObject2(aLayer);
	if (aLayer) {
		if (aLayer.style) {aLayer.style.visibility = (aState)?'inherit':'hidden'};
		if (!aLayer.style) {aLayer.visibility = (aState)?'inherit':'hide'};
	}
}

function sl_showScrollbar(visible) {
	setLayerVisible(this.contentLayer, visible);
	setLayerVisible(this.down, visible);
	setLayerVisible(this.up, visible);
	setLayerVisible(this.thumb, visible);
	setLayerVisible(this.hrtop, visible);
}

function showTextToMedia(mediaName){
	for (i=0;i<videoObjects.length;i++){
		if (videoObjects[i]==mediaName) {
			if(i<=scrollTexts.length) addScrollText(scrollTexts[i]);
			break;
		}
	}
}

//********************************************************************

var aKey = new Array(67,79,79,76,84,85,82,65,18);
var aDebugKey = new Array(68,69,66,85,71,18);
var iKeyIndex = 0;

document.onkeydown = function(e)
{
	if (window.event.keyCode == aKey[iKeyIndex]) {
		iKeyIndex++  
		if (aKey.length == iKeyIndex) {
			iKeyIndex = 0;
			page.showCorrectAnswer();
		}
		return;
	}
	
	if (window.event.keyCode == aDebugKey[iKeyIndex]) {
		iKeyIndex++  
		if (aDebugKey.length == iKeyIndex) {
			iKeyIndex = 0;
			log.showWindow();
		}
		return;
	}
	
	iKeyIndex = 0;
}

//********************************************************************
