LMSManager = function()
{
	this.dummyLMSManager = dummyLMSManager;
	this.dummyLMSManager();
	
	this.csa = this.getCSA();
}

LMSManager.prototype = new dummyLMSManager();

LMSManager.prototype.name = "lmsCSA";

LMSManager.prototype.setPoints = function(points)
{
	if (this.csa) this.csa.setScore(points);
}

LMSManager.prototype.getPoints = function()
{
	return (this.csa) ? this.csa.getScore() : 0;
}

LMSManager.prototype.setStatus = function(status)
{
	if (this.csa) {
		var csaStatus = "n";
		if (status == lms.STATUS_NOT_ATTEMPTED) csaStatus = "n";
		if (status == lms.STATUS_INCOMPLETE) csaStatus = "i";
		if (status == lms.STATUS_FAILED) csaStatus = "f";
		if (status == lms.STATUS_COMPLETED) csaStatus = "c";
		if (status == lms.STATUS_PASSED) csaStatus = "p";
		return this.csa.setStatus(csaStatus);
	}	
};

LMSManager.prototype.getStatus = function()
{
	var csaStatus = "";
	if (this.csa) csaStatus = this.csa.getStatus().toLowerCase();
	if (csaStatus == "n") return lms.STATUS_NOT_ATTEMPTED;
	if (csaStatus == "i") return lms.STATUS_INCOMPLETE;
	if (csaStatus == "f") return lms.STATUS_FAILED;
	if (csaStatus == "c") return lms.STATUS_COMPLETED;
	if (csaStatus == "p") return lms.STATUS_PASSED;
	return lms.STATUS_NOT_ATTEMPTED;
};

LMSManager.prototype.setExercisePassed = function(points)
{
	if (this.csa) {
		this.csa.setScore(points);
		this.csa.setStatus("p");
	}	
}

LMSManager.prototype.setExerciseFailed = function()
{
	if (this.csa) {
		this.csa.setScore(0);
		this.csa.setStatus("f");
	}	
}

LMSManager.prototype.gotoPage = function(indexPage)
{
	if (this.csa) this.csa.gotoPage(indexPage);
}

LMSManager.prototype.nextPage = function()
{
	if (this.csa) this.csa.nextPage();
}

LMSManager.prototype.getCourseData = function(name)
{
	return (this.csa) ? this.csa.getData(name) : null;
}

LMSManager.prototype.setCourseData = function(name, value)
{
	if (this.csa) this.csa.setData(name, value);
}

LMSManager.prototype.prevPage = function()
{
	if (this.csa) this.csa.previousPage();
}

LMSManager.prototype.findCSA = function(win)
{
	if (win.csa != null) return win.csa;

	if (win.length > 0) {
		for (var i = 0; i < win.length; i++) {
			var theCSA = this.findCSA(win.frames[i]);
			if (theCSA != null) return theCSA;
		}
	}
	return null;
}

LMSManager.prototype.getCSA = function()
{
	var theCSA = this.findCSA(parent);
	if (theCSA == null) theCSA = this.findCSA(top);
	if( theCSA == null && typeof(opener) != "undefined" && this.opener != null) theCSA = this.findCSA(opener.top);
	return theCSA;
}

LMSManager.prototype.getSID = function()
{
	if (this.csa) {
		return this.csa.getSID();
	}
	return "";
};

var lms = new LMSManager();
